/**
 * 
 */
package org.pelab.rml.views;

import org.eclipse.ui.console.IConsoleFactory;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleListener;
import org.eclipse.ui.console.IConsoleManager;
import org.pelab.rml.views.RMLTextConsole;
import org.pelab.rml.RMLPlugin;

/**
 * Creates a new console into which users can paste stack traces and follow
 * the hyperlinks.
 * 
 * @author adrpo
 *
 */
public class RMLConsoleFactory implements IConsoleFactory {
    private IConsoleManager fConsoleManager = null;
    private RMLTextConsole fConsole = null;

    public RMLConsoleFactory() {
        fConsoleManager = ConsolePlugin.getDefault().getConsoleManager();
        fConsoleManager.addConsoleListener(new IConsoleListener() {
            public void consolesAdded(IConsole[] consoles) {
            }

            public void consolesRemoved(IConsole[] consoles) {
                for (int i = 0; i < consoles.length; i++) {
                    if(consoles[i] == fConsole) {
                        //fConsole.saveDocument();
                        fConsole = null;
                    }
                }
            }
        
        });
    }
    /* (non-Javadoc)
     * @see org.eclipse.ui.console.IConsoleFactory#openConsole()
     */
    public void openConsole() {
        if (fConsole == null) {
            fConsole = RMLPlugin.getRMLConsole().getConsole(); 
            //fConsole.initializeDocument();
	        fConsoleManager.addConsoles(new IConsole[]{fConsole});
        }
        fConsoleManager.showConsoleView(fConsole);
    }
    
}
